# Peripheral-manager #
----------

Peripheral-manager is the iopsys button and led manager deamon. It is also used to handle sfp modules. Peripheral-manager abstracts
the physical leds into functions. That way the os can have a uniform api across devices. Periferal-manager also supports several ways
to integrate leds and buttons but presents them through a common api.

The buttons and leds are configured dynamically from the /lib/db/config/hw file. Buttons can also be added from the /etc/config/buttons file,
this to add the option to configure enabled buttons from the configuration interface. 

Button support
--------------


For example it is possible to use buttons with a simple gpio interface together with buttons behind a touch controller.



Led support
-----------


Led handling is abstracted by declaring functions instead of physical leds. A functions can then be in several different states and reflect that state 
in several ways.
For example a Broadband function can consist of 2 leds (red and green) at the same physical position. When the function is in the fail state the red led can be lit and when the function is in the ok state the green led can be lit. 



SFP support
-----------

Peripheral-manager supports reading of the sfp rom and ddm data over an i2c bus. The data can be queried over ubus.


The following command will list all available rom object methods:
```
ubus list -v sfp.rom
'sfp.rom' @48feb720
        "get-type":{}
        "get-connector":{}
        "get-ethernet":{}
        "get-encoding":{}
        "get-rate":{}
        "get-length":{}
        "get-vendor":{}
        "get-oui":{}
        "get-pn":{}
        "get-rev":{}
        "get-sn":{}
        "get-date":{}
        "get-ddm":{}
        "get-all":{}
```
Changeing rom to ddm with get the ddm object methods:

```
ubus list -v sfp.ddm
'sfp.ddm' @7ba2fcb2
        "get-rx-pwr":{}
        "get-tx-pwr":{}
        "get-current":{}
        "get-voltage":{}
        "get-all":{}

```


The following command will query the sfp for all rom parameters:
```
ubus call sfp.rom get-all
{
        "connector": "SC",
        "ethernet": "LX",
        "encoding": "8B10B",
        "rate": 1300,
        "single-mode": 20000,
        "vendor": "Skylane Optics",
        "oui": "00:25:cd",
        "pn": "SBU35020DR3D000",
        "rev": "A",
        "sn": "b1lq5kmy2626",
        "date": "2015-09-28",
        "ddm": "9.3"
}
```

The following command will query the sfp for all ddm parameters:
```
ubus call sfp.ddm get-all
{
        "voltage": "3.2376 V",
        "current": "30.864 mA",
        "tx-pwr": "0.3012 mW",
        "tx-pwr-dBm": "-5.2115 dBm",
        "rx-pwr": "0.0002 mW",
        "rx-pwr-dBm": "-36.9897 dBm",
        "rx-pwr-type": "average"
}
```

