#!/bin/sh

#Tools for unit testing , code analysis and code coverage.
apt-get update && DEBIAN_FRONTEND=noninteractive apt-get install -y \
      	git \
      	cmake \
      	wget \
      	build-essential \
      	lcov \
      	apt-utils \
      	autoconf \
      	automake \
      	pkg-config \
      	libtool \
      	vim \
      	valgrind \
      	gdb \
      	cppcheck \
      	python3 \
      	python3-setuptools \
      	openssh-server \
      	clang-format \
      	sudo \
      	strace \
      	supervisor \
      	net-tools \
      	iputils-ping \
        lua5.1-dev \
        lua5.1 \
        libssl-dev \
        libuv1-dev \
        cmocka-doc \
        libcmocka-dev \
        libcmocka0


# Configure OpenSSH server

mkdir /var/run/sshd && \
echo 'root:root' | chpasswd && \
sed -i 's/PermitRootLogin prohibit-password/PermitRootLogin yes/' /etc/ssh/sshd_config && \
sed -i 's/PermitEmptyPasswords no/PermitEmptyPasswords yes/' /etc/ssh/sshd_config && \
sed 's@session\s*required\s*pam_loginuid.so@session optional pam_loginuid.so@g' -i /etc/pam.d/sshd

# Configure gdb-dashboard

easy_install3 pip && \
pip3 install Pygments
wget -P ~ git.io/.gdbinit

mkdir ~/.gdbinit.d && \
touch ~/.gdbinit.d/init && \
echo "dashboard -layout source" >> ~/.gdbinit.d/init && \
echo "dashboard source -style context 20" >> ~/.gdbinit.d/init && \
echo "dashboard -style syntax_highlighting 'monokai'" >> ~/.gdbinit.d/init

#Craete directory to copy supervisior config and uci config file 
mkdir /etc/config && \
mkdir -p /var/log/supervisor


# last !
rm -rf /var/lib/apt/lists/*

